<script setup>
import { format } from "date-fns";

const props = defineProps({
  name: {
    type: String,
    required: true,
  },
  uid: {
    type: String,
  },
  base_64_image: {
    type: String,
  },
  start_date: {
    type: String,
    required: true,
  },
  end_date: {
    type: String,
    required: true,
  },
  start_hour: {
    type: String,
    required: true,
  },
  end_hour: {
    type: String,
    required: true,
  },
  category: {
    type: String,
    required: true,
  },
  parent: {
    type: String,
    required: true,
  },
  location: {
    type: String,
    required: true,
  },
});

const nuxt_link = computed(() => {
  return props.uid != null ? `/gallery/${props.uid}` : "#";
});

const date_fin = computed(() => {
  try {
    if (props.end_date) {
      let d = new Date(props.end_date);
      return getLabelDayOfWeek(d) + " " + format(d, "dd/MM");
    }

    return "";
  }
  catch (err) {
    console.error("date_fin error", { err })
    return "";
  }
});

const bg_image = computed(() => {
  let src = "";
  if (props.parent == null) {
    src = `/images/${props.category.toLowerCase()}.svg`;
  } else {
    src = `/images/${props.parent.toLowerCase()}.svg`;
  }
  return src;
});
</script>

<template>
  <NuxtLink :to="nuxt_link"
    :class="`relative w-full min-w-44 max-w-48 h-full min-h-64 rounded-t-xl bg-white`">
    <img :src="base_64_image ?? bg_image" class="absolute h-full aspect-auto w-full rounded-xl">
    <img src="/images/bg_date_event.svg" class="absolute h-11 aspect-auto -left-1 top-0"></img>
    <img src="/images/bg_lieu_event.svg" class="absolute h-11 aspect-auto -right-1 top-0 rounded-xl"></img>

    <div class="flex flex-col justify-between h-full w-full absolute">
      <div class="flex flex-row justify-between font-las p-1">
        <DisplayTime :start_date="start_date" :end_date="end_date" :start_hour="start_hour"
          :end_hour="end_hour" />
        <div class="text-xs text-las-orange font-bold">
          {{ category }}
        </div>
      </div>

      <div class="flex flex-col">
        <div class="flex flex-col bg-las-orange text-white h-full min-h-16 rounded-las-event justify-center">
          <div class="font-bold leading-4 text-base+ text-center">
            {{ name }}
          </div>
          <div class="leading-4 text-center text-sm">
            {{ location }}
          </div>
        </div>

        <div v-if="start_date !== end_date" class="flex text-las-orange bg-white justify-center text-xs border-orange-400 border-b-2 border-l-2 border-r-2">
          Jusqu'au {{ date_fin }}
        </div>
      </div>

    </div>
  </NuxtLink>
</template>
